#ifndef __EXPR_H_dud2
#define __EXPR_H_dud2

#ifndef MAKEDEPEND
#include <string>
#include <memory>
using namespace std;
#endif

#define iscopy !??!?!
#define expr_floattype long double
#define expr_format    "%.20Lg"
#define expr_longtype  unsigned long long
#define expr_longfunc  strtoull
#define expr_floatfunc strtold
#define expr_fmod_fun  fmodl
#define expr_modf_fun  modfl
#define expr_pow_fun   powl
#define expr_need_l    1       // for sin##l, cos##l etc. Use if long double.

#ifdef DUD2
 #include "obj.h"
 #define calculate_args run_args
 #define calculate_call run_call
 #define calculate_args_notused run_args_notused
#else
 #define calculate_args
 #define calculate_call
 #define calculate_args_notused
#endif

// Lower number here means less priority.
enum {
	prio_nothing=0,
	prio_arglist,	
	prio_assignment,
	prio_conditional,
	prio_boolean,
	prio_equality,
	prio_relational,
	prio_additive,
	prio_divmul,
	prio_expon,
	prio_huuto,
	prio_high
};

enum expr_type
{
	ext_expr,
	ext_pairfun,
	ext_minusplus,
	ext_fractions,
	ext_number
};

#include "autoptr.h"

typedef autoptr<class expr> exprp;

class expr
{
public:
/*	template<class t> friend autoptr<t>;
*/	int refnum;
public:
	expr_type ID;
	
	bool valid;
	enum {str,num,notsure} type;
	bool isconst;
	expr() : ID(ext_expr), valid(true), type(notsure), isconst(false) { }
	virtual exprp load(string &input, int prio=prio_nothing);
	virtual ~expr();
	
	virtual exprp optimize();	
	virtual exprp calculate(calculate_args) const;
	
	virtual const string getstr() const;
	virtual const expr_floattype getnum() const;
	virtual const string getname() const;
	virtual const bool truth() const;
	#ifdef DUD2
	virtual exprp &getvar(calculate_args) const;
	virtual class obj *getobj(calculate_args) const;
	#endif
};

#endif
